## ott 0.32+ds

=== coq/Makefile ===
default: Makefile.coq
	$(MAKE) -f Makefile.coq

install: Makefile.coq
	$(MAKE) -f Makefile.coq install

Makefile.coq: _CoqProject
	coq_makefile -f _CoqProject -o Makefile.coq

clean: Makefile.coq
	$(MAKE) -f Makefile.coq cleanall
	rm -f Makefile.coq Makefile.coq.conf

.PHONY: default clean install

=== src/Makefile ===
#########################################################################
#                                   Ott                                  #
#                                                                        #
#        Peter Sewell, Computer Laboratory, University of Cambridge      #
#      Francesco Zappa Nardelli, Moscova project, INRIA Rocquencourt     #
#                                                                        #
#  Copyright 2005-2017                                                   #
#                                                                        #
#  Redistribution and use in source and binary forms, with or without    #
#  modification, are permitted provided that the following conditions    #
#  are met:                                                              #
#  1. Redistributions of source code must retain the above copyright     #
#  notice, this list of conditions and the following disclaimer.         #
#  2. Redistributions in binary form must reproduce the above copyright  #
#  notice, this list of conditions and the following disclaimer in the   #
#  documentation and/or other materials provided with the distribution.  #
#  3. The names of the authors may not be used to endorse or promote     #
#  products derived from this software without specific prior written    #
#  permission.                                                           #
#                                                                        #
#  THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS    #
#  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED     #
#  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE    #
#  ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY       #
#  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL    #
#  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE     #
#  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS         #
#  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER  #
#  IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR       #
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN   #
#  IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                         #
##########################################################################

topdir = ..

OTTVER=0.32

# for us
OCAMLC	 	= ocamlc -g -dtypes  # -w p disables partial match warnings
OCAMLOPT	= ocamlopt -w y -g -dtypes -unsafe -inline 9

# for releases
#OCAMLC	 	= ocamlc -g -w p -w y
#OCAMLOPT	= ocamlopt -w p -w y -unsafe -inline 9

OCAMLDEP 	= ocamldep
OCAMLLEX        = ocamllex
OCAMLYACC       = ocamlyacc

LATEX		= latex
DVIPS		= dvips
DVIPDFM		= dvipdfm

COQC            = coqc
COQ_INCLUDE     = -I $(topdir)/coq
COQ_FLAGS       =
OCAMLGRAPHDIRBODY = ocamlgraph-1.7
OCAMLGRAPHDIR = $(topdir)/$(OCAMLGRAPHDIRBODY)
OCAMLGRAPHTARGZ	= ocamlgraph-1.7.tar.gz
LIBRARIES	= str $(OCAMLGRAPHDIR)/graph

# DO NOT EDIT BELOW THIS LINE ###########################################

SOURCES_LEXER_PARSER = grammar_lexer.mll grammar_parser.mly

SOURCES_NON_LEXER_PARSER1 = location.ml types.ml auxl.ml merge.ml global_option.ml

SOURCES_NON_LEXER_PARSER2 = grammar_pp.ml parse_table.ml glr.ml new_term_parser.ml term_parser.ml \
			    dependency.ml bounds.ml context_pp.ml \
	                    quotient_rules.ml grammar_typecheck.ml 		  \
			    transform.ml substs_pp.ml subrules_pp.ml				  \
			    embed_pp.ml defns.ml ln_transform.ml coq_induct.ml	  		  \
                            system_pp.ml lex_menhir_pp.ml align.ml main.ml




SOURCES_MLI =           \
  align.mli             \
  bounds.mli            \
  coq_induct.mli        \
  defns.mli             \
  dependency.mli        \
  embed_pp.mli          \
  grammar_typecheck.mli \
  merge.mli             \
  subrules_pp.mli       \
  substs_pp.mli         \
  system_pp.mli         \
  lex_menhir_pp.mli         \
  transform.mli		\
  term_parser.mli

SOURCES= $(SOURCES_NON_LEXER_PARSER1) 					\
         grammar_lexer.ml grammar_parser.mli grammar_parser.ml 		\
	 version.ml 							\
         $(SOURCES_NON_LEXER_PARSER2)

MLI 	= $(filter %.mli, $(SOURCES))
ML	= $(filter %.ml, $(SOURCES))

CMO 	= $(patsubst %.ml, %.cmo, $(ML))
CMX 	= $(patsubst %.cmo, %.cmx, $(CMO))

CMI_FROM_MLI = $(patsubst %.mli, %.cmi, $(SOURCES_MLI))


#default: ott.opt
default: ott.byt

all: default
ott: default


# compile and link Ott

byt: ott.byt

ott.byt: Makefile $(CMO) $(CMI_FROM_MLI) version.tex
	echo $^
	$(OCAMLC) -v
	$(OCAMLC) -o ott.byt $(addsuffix .cma, $(LIBRARIES)) $(CMO)
	ln -s -f $@ ott

.FORCE: opt
opt: ott.opt

ott.opt: Makefile $(CMX) $(CMI_FROM_MLI) version.tex
	echo $^
	$(OCAMLOPT) -v
	$(OCAMLOPT) -o ott.opt $(addsuffix .cmxa, $(LIBRARIES)) $(CMX)
	ln -s -f $@ ott

interfaces: $(ML:.ml=.interface)

mlis: $(ML:.ml=.mli)

# files that require a special treatment

grammar_lexer.ml: grammar_lexer.mll
	$(OCAMLLEX) grammar_lexer.mll

grammar_parser.ml grammar_parser.mli: grammar_parser.mly
	$(OCAMLYACC) -v grammar_parser.mly

grammar_typecheck.cmo: grammar_typecheck.ml
	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) grammar_typecheck.ml

grammar_typecheck.cmx: grammar_typecheck.ml
	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) grammar_typecheck.ml

glr.cmo: glr.ml
	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) glr.ml

glr.cmx: glr.ml
	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) glr.ml

parse_table.cmo: parse_table.ml
	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) parse_table.ml

parse_table.cmx: parse_table.ml
	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) parse_table.ml

new_term_parser.cmo: new_term_parser.ml
	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) new_term_parser.ml

new_term_parser.cmx: new_term_parser.ml
	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) new_term_parser.ml

dependency.cmo: dependency.ml
	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) dependency.ml

dependency.cmx: dependency.ml
	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) dependency.ml

#version.ml: Makefile tmp_date.txt
#	echo let n=\"$(OTTVER)\" > tmp_version1.ml
#	echo -n let d=\" > tmp_version2.ml
#	echo \" > tmp_version3.ml
#	cat tmp_version1.ml tmp_version2.ml tmp_date.txt tmp_version3.ml > version.ml
#	rm tmp_version1.ml tmp_version2.ml tmp_version3.ml

version.ml: tmp_date.txt Makefile #Makefile-core
	echo 'let n="$(OTTVER)"' >version.ml
	echo let d=\"$$(cat tmp_date.txt)\" >>version.ml

version.tex: tmp_date.txt version_src.tex Makefile
	sed -e 's/__VERSION__/$(OTTVER)/' \
	    -e '/__DATE__/r tmp_date.txt' \
	    -e '/__DATE__/d' <version_src.tex >version.tex
#	sed -e 's/__VERSION__/$(OTTVER)/' \
#	    -e "s/__DATE__/$$(cat tmp_date.txt)/" <version_src.tex >version.tex

# common rules

%.cmi: %.mli
	$(OCAMLC) -I $(OCAMLGRAPHDIR) -c $<

%.interface: %.ml
	$(OCAMLC) -I $(OCAMLGRAPHDIR) -i $< >$@

#%.mli: %.ml
#	$(OCAMLC) -I $(OCAMLGRAPHDIR) -i $< >$@

%.cmo: %.ml
	$(OCAMLC) -c $<

%.cmx: %.ml
	$(OCAMLOPT) -I $(OCAMLGRAPHDIR) -c $<

%.ps : %.dot
	dot -Tps $< > $@

%.png : %.dot
	dot -Tpng -Gsize="2,2" $< > $@

%.vo: %.v
	$(COQC) $(COQ_INCLUDE) $(COQ_FLAGS) $<

# INSTALL  ##############################################################

## Rules to unpack and build our copy of ocamlgraph.
$(OCAMLGRAPHDIR)/Makefile:
	cd $(topdir) && tar -zxvf $(OCAMLGRAPHTARGZ)
	cd $(OCAMLGRAPHDIR) && patch -p1 < $(topdir)/ocamlgraph-safe-string.patch
	cd $(OCAMLGRAPHDIR) && ./configure
$(OCAMLGRAPHDIR)/graph.cma: $(OCAMLGRAPHDIR)/Makefile
	cd $(OCAMLGRAPHDIR) && $(MAKE) graph.cma
$(OCAMLGRAPHDIR)/graph.cmxa: $(OCAMLGRAPHDIR)/Makefile
	cd $(OCAMLGRAPHDIR) && \
	$(MAKE) OCAMLOPT='$(OCAMLOPT) -I src -I lib' graph.cmxa
# The extra `-I' options when building graph.cmxa work around OCaml
# PR#4124 (present in OCaml 3.09.*).
ocamlgraph: $(OCAMLGRAPHDIR)/graph.cma $(OCAMLGRAPHDIR)/graph.cmxa

$(topdir)/bin:
	mkdir $(topdir)/bin

install.byt: $(topdir)/bin $(OCAMLGRAPHDIR)/graph.cma
	$(MAKE) byt
	cp ./ott $(topdir)/bin/ott

install: $(topdir)/bin $(OCAMLGRAPHDIR)/graph.cmxa
	$(MAKE) opt
	cp ./ott $(topdir)/bin/ott



# LIBRARY ##############################################################

coq-lib:
	cd $(topdir)/coq && $(MAKE) all


# GRAMMAR DOCS ##########################################################

# magic to tex-ify our yacc parser

Y2L=../aux/y2l/y2l  

%.mly-y2l : %.mly
	cat $< | tr -d \' | grep -v '%start' | grep -v '%type' | sed -e 's/%prec [^ ]*//' > $@

grammar_parser.tex : grammar_parser.mly-y2l  $(Y2L)
	$(Y2L) $< -O2  > $@
#
# not sure if the parser-tokens.y2l can be autogenerated or if we 
# have to write it by hand (hacking grammar_parser.mli
# (cf ../../Impl/acute/parser-tokens.y2l).  If omitting it, use
# the grammar_parser.tex rule above instead of this below
#
#%.tex : %.mly-y2l parser-tokens.y2l $(Y2L)
#	$(Y2L) $< -O2 -tparser-tokens.y2l > $@

grammar.ps : grammar.tex grammar_parser.tex
	$(LATEX) grammar.tex
	$(DVIPS) $(DVIPSOPTS) grammar.dvi


# EXAMPLES USED IN MANUAL ##############################################

tmp_test7_clean.ott: ../tests/test7.ott
	rm -f tmp_test7_clean.ott
	(grep -v ^a | sed -e 's/^r//g' | grep -v ^% ) < ../tests/test7.ott > tmp_test7_clean.ott
	chmod ugo-w tmp_test7_clean.ott


# DOT IMAGES FOR WEB PAGE  ###############################################

tmp_test7.ott: ../tests/test7.ott
	rm -f tmp_test7.ott
	(sed -e 's/^r//g') < ../tests/test7.ott > tmp_test7.ott
	chmod ugo-w tmp_test7.ott


test7: ott  tmp_test7.ott
	./ott  -o out.tex 						\
	       -dot tmp_test7_dot.dot 					\
	       -o out.thy -o outScript.sml -o out.v		\
	        -parse ":user_syntax: \x1':X.x1'"  			\
	        -parse ":user_syntax: :user_syntax__t: \x1':X.x1'"  	\
	        -parse ":user_syntax: :user_syntax__t: :concrete: \x1':X.x1'"  \
	        -parse ":user_syntax: :concrete: \x1':X.x1'"  		\
	        -parse ":concrete_t:\x1':X.x1'"                      	\
	        -parse ":Jop: match({l1=p1,..,lm=pm},{k1=v1,..,kn=vn}) = s1,..,sm" \
               tmp_test7.ott 						\
        && ($(LATEX) out; $(DVIPS) out -o; $(DVIPDFM) out)


%.ps : %.dot
	dot -Tps $< > $@

%.png : %.dot
	dot -Tpng -Gsize="2,2" $< > $@



#%.gif : %.dot
#	dot -Tgif -Gsize="2,2" $< > $@


# WEB PAGE INSTALL ###################################################


tmp_index.html: ../doc/index.html.p 
	cat ../doc/index.html.p | \
	sed -e "s/OTTVERSION/$(OTTVER)/g" > tmp_index.html

install-www-index: tmp_index.html 
	$(MAKE) test7
	$(MAKE) tmp_test7_dot.ps
	$(MAKE) tmp_test7_dot.png
	cp -f tmp_index.html ~/public_html/ott/index.html
	cp -f ../doc/style.css ~/public_html/ott
	cp -f ../doc/favicon.ico ~/public_html/ott
	cp -f ../revision_history.txt ~/public_html/ott
	cp -f ../README.md ~/public_html/ott/README.txt
	cp -f tmp_test7_dot.ps ~/public_html/ott/test7.dot.ps
	cp -f tmp_test7_dot.png ~/public_html/ott/test7.dot.png
	chmod ugo-w ~/public_html/ott/index.html
	chmod ugo-w ~/public_html/ott/style.css
	chmod ugo-w ~/public_html/ott/revision_history.txt



# CLEANUP ##############################################################

clean:
	rm -f *~ *.cmi *.cmo *.cmx *.o
	rm -f grammar_lexer.ml grammar_parser.ml 			\
              grammar_parser.mli grammar_parser.output
	rm -f version.ml
	rm -rf ott ott.byt ott.opt $(topdir)/bin/ott
	rm -f grammar_parser.tex *.mly-y2l
	rm -f *.aux *.log *.dvi *.ps *.pdf *.annot
	rm -f out.thy out.v outScript.sml outTheory.uo outTheory.ui outTheory.sig outTheory.sml out.tex out.sty 
	rm -f tmp_*.dot tmp.dot
	rm -f tmp_*.ott
	rm -f testRegr*
	rm -f *Theory.* *.ui *.uo
	rm -rf $(OCAMLGRAPHDIR)

realclean:
	rm -f .depend
	cd $(topdir)/coq && $(MAKE) clean


# DEPENDENCIES ########################################################

foob:
	echo $(SOURCES)

depend:
	$(OCAMLDEP) $(SOURCES) $(SOURCES_MLI) > .depend
.depend: Makefile $(SOURCES) $(SOURCES_MLI)
	$(OCAMLDEP) $(SOURCES) $(SOURCES_MLI) > .depend

include .depend

=== examples/ocaml_light/hol/ocamlpp/Makefile ===

CAMLC=ocamlc
CAMLOPT=ocamlopt
COMPFLAGS=-warn-error A $(INCLUDES)
LINKFLAGS=

CAMLYACC=ocamlyacc
YACCFLAGS=-v
CAMLLEX=ocamllex
CAMLDEP=ocamldep
DEPFLAGS=$(INCLUDES)
CAMLRUN=ocamlrun
SHELL=/bin/sh
MKDIR=mkdir -p

INCLUDES=-I utils -I parsing 

UTILS=utils/misc.cmx utils/tbl.cmx utils/config.cmx \
  utils/clflags.cmx utils/terminfo.cmx utils/ccomp.cmx utils/warnings.cmx \
  utils/consistbl.cmx

OPTUTILS=$(UTILS)

PARSING=parsing/linenum.cmx parsing/location.cmx parsing/longident.cmx \
  parsing/syntaxerr.cmx parsing/parser.cmx \
  parsing/lexer.cmx parsing/parse.cmx parsing/printast.cmx 

FILES=$(UTILS) $(PARSING) main.cmx

filter: $(FILES) Makefile
	$(CAMLOPT) $(LINKFLAGS) -o filter $(FILES)


parsing/parser.mli parsing/parser.ml: parsing/parser.mly
	$(CAMLYACC) $(YACCFLAGS) parsing/parser.mly


parsing/lexer.ml: parsing/lexer.mll
	$(CAMLLEX) parsing/lexer.mll


parsing/linenum.ml: parsing/linenum.mll
	$(CAMLLEX) parsing/linenum.mll


.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.cmo:
	$(CAMLC) $(COMPFLAGS) -c $<

.mli.cmi:
	$(CAMLC) $(COMPFLAGS) -c $<

.ml.cmx:
	$(CAMLOPT) $(COMPFLAGS) -c $<

clean::
	rm -f utils/*.cm[iox] utils/*.[so] utils/*~
	rm -f parsing/*.cm[iox] parsing/*.[so] parsing/*~
	rm -f parsing/parser.ml parsing/parser.mli parsing/parser.output
	rm -f parsing/lexer.mli parsing/lexer.ml
	rm -f *.cm[iox] *.[so] *~ filter

depend: 
	(for d in utils parsing .; \
	 do $(CAMLDEP) $(DEPFLAGS) $$d/*.mli $$d/*.ml; \
	 done) > .depend

FORCE:

include .depend

=== debian/changelog ===
ott (0.32+ds-3) unstable; urgency=medium

  * Change b-dep from libcoq-ocaml-dev to libcoq-core-ocaml-dev.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 25 Jan 2023 09:49:04 +0100

ott (0.32+ds-2) unstable; urgency=medium

  * Complete d/copyright.
  * Add patch to fix typos.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 10 Jul 2022 18:17:48 +0200

ott (0.32+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1014610)

 -- Julien Puydt <jpuydt@debian.org>  Fri, 08 Jul 2022 20:48:48 +0200

=== debian/control ===
Source: ott
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Section: ocaml
Priority: optional
Standards-Version: 4.6.1
Rules-Requires-Root: no
Build-Depends: coq,
               debhelper-compat (= 13),
               dh-coq,
               dh-ocaml,
               help2man,
               hevea,
               libcoq-core-ocaml-dev,
               libcoq-stdlib,
               libocamlgraph-ocaml-dev,
               pandoc
Vcs-Browser: https://salsa.debian.org/ocaml-team/ott
Vcs-Git: https://salsa.debian.org/ocaml-team/ott.git
Homepage: https://github.com/ott-lang/ott

Package: libcoq-ott
Architecture: any
Depends: ${coq:Depends}, ${misc:Depends}
Provides: ${coq:Provides}
Description: Ott tool (Coq plugin)
 Ott is a tool to write definitions of programming
 languages and calculi. From the definition of a
 language syntex and semanticsin a concise and readable
 notation close to informal mathematics, it can
 provide LaTeX, Coq, HOL, Isabelle/HOL, Lem or OCaml
 versions of the definition.
 .
 Coq is a proof assistant for higher-order logic.
 .
 This package provides the Coq plugin itself.

Package: ott-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ott tool (executable)
 Ott is a tool to write definitions of programming
 languages and calculi. From the definition of a
 language syntex and semanticsin a concise and readable
 notation close to informal mathematics, it can
 provide LaTeX, Coq, HOL, Isabelle/HOL, Lem or OCaml
 versions of the definition.
 .
 Coq is a proof assistant for higher-order logic.
 .
 This package provides the executable.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with coq,ocaml

override_dh_auto_clean:
	# doesn't work

override_dh_auto_build:
	make -C coq
	make -C src
	make -C doc top2.html
	help2man -N src/ott > debian/ott.1

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp make -C coq install
	DESTDIR=$(CURDIR)/debian/tmp make -C src install

## ott 0.33%2Bds

=== src/Makefile ===
--- 
+++ 
@@ -33,15 +33,18 @@
 
 topdir = ..
 
-OTTVER=0.32
+OTTVER=0.33
+
+OCAMLFIND=ocamlfind
+OCAMLARGS=-package str -package ocamlgraph -linkpkg
 
 # for us
-OCAMLC	 	= ocamlc -g -dtypes  # -w p disables partial match warnings
-OCAMLOPT	= ocamlopt -w y -g -dtypes -unsafe -inline 9
+OCAMLC	 	= $(OCAMLFIND) ocamlc $(OCAMLARGS) -g -dtypes  # -w p disables partial match warnings
+OCAMLOPT	= $(OCAMLFIND) ocamlopt $(OCAMLARGS) -w y -g -dtypes -unsafe -inline 9
 
 # for releases
-#OCAMLC	 	= ocamlc -g -w p -w y
-#OCAMLOPT	= ocamlopt -w p -w y -unsafe -inline 9
+#OCAMLC	 	= $(OCAMLFIND) ocamlc $(OCAMLARGS) -g -w p -w y
+#OCAMLOPT	= $(OCAMLFIND) ocamlopt $(OCAMLARGS) -w p -w y -unsafe -inline 9
 
 OCAMLDEP 	= ocamldep
 OCAMLLEX        = ocamllex
@@ -54,10 +57,6 @@
 COQC            = coqc
 COQ_INCLUDE     = -I $(topdir)/coq
 COQ_FLAGS       =
-OCAMLGRAPHDIRBODY = ocamlgraph-1.7
-OCAMLGRAPHDIR = $(topdir)/$(OCAMLGRAPHDIRBODY)
-OCAMLGRAPHTARGZ	= ocamlgraph-1.7.tar.gz
-LIBRARIES	= str $(OCAMLGRAPHDIR)/graph
 
 # DO NOT EDIT BELOW THIS LINE ###########################################
 
@@ -119,7 +118,7 @@
 ott.byt: Makefile $(CMO) $(CMI_FROM_MLI) version.tex
 	echo $^
 	$(OCAMLC) -v
-	$(OCAMLC) -o ott.byt $(addsuffix .cma, $(LIBRARIES)) $(CMO)
+	$(OCAMLC) -o ott.byt $(CMO)
 	ln -s -f $@ ott
 
 .FORCE: opt
@@ -128,7 +127,7 @@
 ott.opt: Makefile $(CMX) $(CMI_FROM_MLI) version.tex
 	echo $^
 	$(OCAMLOPT) -v
-	$(OCAMLOPT) -o ott.opt $(addsuffix .cmxa, $(LIBRARIES)) $(CMX)
+	$(OCAMLOPT) -o ott.opt $(CMX)
 	ln -s -f $@ ott
 
 interfaces: $(ML:.ml=.interface)
@@ -144,34 +143,34 @@
 	$(OCAMLYACC) -v grammar_parser.mly
 
 grammar_typecheck.cmo: grammar_typecheck.ml
-	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) grammar_typecheck.ml
+	$(OCAMLC) -c grammar_typecheck.ml
 
 grammar_typecheck.cmx: grammar_typecheck.ml
-	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) grammar_typecheck.ml
+	$(OCAMLOPT) -c grammar_typecheck.ml
 
 glr.cmo: glr.ml
-	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) glr.ml
+	$(OCAMLC) -c glr.ml
 
 glr.cmx: glr.ml
-	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) glr.ml
+	$(OCAMLOPT) -c glr.ml
 
 parse_table.cmo: parse_table.ml
-	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) parse_table.ml
+	$(OCAMLC) -c parse_table.ml
 
 parse_table.cmx: parse_table.ml
-	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) parse_table.ml
+	$(OCAMLOPT) -c parse_table.ml
 
 new_term_parser.cmo: new_term_parser.ml
-	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) new_term_parser.ml
+	$(OCAMLC) -c new_term_parser.ml
 
 new_term_parser.cmx: new_term_parser.ml
-	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) new_term_parser.ml
+	$(OCAMLOPT) -c new_term_parser.ml
 
 dependency.cmo: dependency.ml
-	$(OCAMLC) -c -I $(OCAMLGRAPHDIR) dependency.ml
+	$(OCAMLC) -c dependency.ml
 
 dependency.cmx: dependency.ml
-	$(OCAMLOPT) -c -I $(OCAMLGRAPHDIR) dependency.ml
+	$(OCAMLOPT) -c dependency.ml
 
 #version.ml: Makefile tmp_date.txt
 #	echo let n=\"$(OTTVER)\" > tmp_version1.ml
@@ -194,19 +193,19 @@
 # common rules
 
 %.cmi: %.mli
-	$(OCAMLC) -I $(OCAMLGRAPHDIR) -c $<
+	$(OCAMLC) -c $<
 
 %.interface: %.ml
-	$(OCAMLC) -I $(OCAMLGRAPHDIR) -i $< >$@
+	$(OCAMLC) -i $< >$@
 
 #%.mli: %.ml
-#	$(OCAMLC) -I $(OCAMLGRAPHDIR) -i $< >$@
+#	$(OCAMLC) -i $< >$@
 
 %.cmo: %.ml
 	$(OCAMLC) -c $<
 
 %.cmx: %.ml
-	$(OCAMLOPT) -I $(OCAMLGRAPHDIR) -c $<
+	$(OCAMLOPT) -c $<
 
 %.ps : %.dot
 	dot -Tps $< > $@
@@ -219,28 +218,14 @@
 
 # INSTALL  ##############################################################
 
-## Rules to unpack and build our copy of ocamlgraph.
-$(OCAMLGRAPHDIR)/Makefile:
-	cd $(topdir) && tar -zxvf $(OCAMLGRAPHTARGZ)
-	cd $(OCAMLGRAPHDIR) && patch -p1 < $(topdir)/ocamlgraph-safe-string.patch
-	cd $(OCAMLGRAPHDIR) && ./configure
-$(OCAMLGRAPHDIR)/graph.cma: $(OCAMLGRAPHDIR)/Makefile
-	cd $(OCAMLGRAPHDIR) && $(MAKE) graph.cma
-$(OCAMLGRAPHDIR)/graph.cmxa: $(OCAMLGRAPHDIR)/Makefile
-	cd $(OCAMLGRAPHDIR) && \
-	$(MAKE) OCAMLOPT='$(OCAMLOPT) -I src -I lib' graph.cmxa
-# The extra `-I' options when building graph.cmxa work around OCaml
-# PR#4124 (present in OCaml 3.09.*).
-ocamlgraph: $(OCAMLGRAPHDIR)/graph.cma $(OCAMLGRAPHDIR)/graph.cmxa
-
 $(topdir)/bin:
 	mkdir $(topdir)/bin
 
-install.byt: $(topdir)/bin $(OCAMLGRAPHDIR)/graph.cma
+install.byt: $(topdir)/bin
 	$(MAKE) byt
 	cp ./ott $(topdir)/bin/ott
 
-install: $(topdir)/bin $(OCAMLGRAPHDIR)/graph.cmxa
+install: $(topdir)/bin
 	$(MAKE) opt
 	cp ./ott $(topdir)/bin/ott
 
@@ -358,7 +343,6 @@
 	rm -f tmp_*.ott
 	rm -f testRegr*
 	rm -f *Theory.* *.ui *.uo
-	rm -rf $(OCAMLGRAPHDIR)
 
 realclean:
 	rm -f .depend

=== tests/menhir_tests/test_if/Makefile ===
#  make -C ../.. && make clean && make

ROOT            := test_if

OTTDIR          := ../../..

OTT             := $(OTTDIR)/bin/ott

MENHIR_EXTRA_LIB:= $(OTTDIR)/menhir/menhir_library_extra.mly

MENHIR          := menhir

MENHIRFLAGS     := --infer --explain --unused-tokens --trace --base $(ROOT)_parser

OCAMLBUILD      := ocamlbuild -use-ocamlfind -use-menhir -menhir "$(MENHIR) $(MENHIRFLAGS) ../$(MENHIR_EXTRA_LIB) " -package pprint

MAIN            := main

all: $(ROOT)_ast.ml $(ROOT)_parser.mly $(ROOT)_parser_pp.ml $(ROOT)_lexer.mll main.ml 
	$(OCAMLBUILD) $(MAIN).byte


pdf: $(ROOT)_quotiented.pdf $(ROOT)_unquotiented.pdf

# generate the ocaml AST type, ocamllex lexer, menhir parser, and ocaml pretty printers for the AST, all from the Ott soruce
$(ROOT)_ast.ml  $(ROOT)_lexer.mll $(ROOT)_parser.mly $(ROOT)_parser_pp.ml $(ROOT)_ast.tex : $(ROOT).ott
	$(OTT) -show_sort true -quotient_rules false -i $(ROOT).ott  -o $(ROOT)_parser.mly -o $(ROOT)_lexer.mll -o $(ROOT)_ast.ml -o $(ROOT).tex


$(ROOT)_quotiented.pdf: $(ROOT).ott Makefile
	$(OTT) -quotient_rules true -i $(ROOT).ott -o $(ROOT)_quotiented.tex
	pdflatex $(ROOT)_quotiented.tex

$(ROOT)_unquotiented.pdf: $(ROOT).ott Makefile
	$(OTT) -quotient_rules false -i $(ROOT).ott -o $(ROOT)_unquotiented.tex
	pdflatex $(ROOT)_unquotiented.tex

clean:
	rm -rf *~
	rm -rf _build
	rm -rf $(ROOT)_ast.ml $(ROOT)_parser.mly $(ROOT)_lexer.mll $(ROOT)_parser_pp.ml
	rm -rf *.aux *.log *.tex
	rm -rf main.native main.byte
	$(OCAMLBUILD) -clean

realclean:
	$(MAKE) clean
	rm -rf *.pdf

=== debian/changelog ===
ott (0.33+ds-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:11:24 +1100

ott (0.33+ds-2build2) noble; urgency=medium

  * No-change rebuild for new libcoq-stdlib ABI

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 24 Mar 2024 00:16:17 +0000

ott (0.33+ds-2build1) noble; urgency=medium

  * Rebuild against latest coq

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 22 Dec 2023 21:05:57 -0500

ott (0.33+ds-2) unstable; urgency=medium

  * Fix d/rules clean target (Closes: #1049273).

 -- Julien Puydt <jpuydt@debian.org>  Thu, 21 Dec 2023 16:34:16 +0100

ott (0.33+ds-1) unstable; urgency=medium

  * New upstream release.
  * Refresh packaging.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 12 Jun 2023 19:35:45 +0200

## ott 0.33+ds

=== doc/Makefile ===
LATEX		= latex
DVIPS		= dvips
DVIPSFLAGS = -Ppdf -j0 -G0 -t a4
#DVIPSFLAGS = -Ppdf -j0 -G0 -t letter


FIGURES=ich_fig0 ich_fig1
#ich_fig_FIG_OPTS=-m 0.55
FIGURE_PSTEX_TS=$(addsuffix .pstex_t, $(FIGURES))


# to make manual for new release:
#     bump new version in ../Makefile
#     date > tmp_date.txt  in ../src/
#     make in .. to rebuild version.tex
#     make install-top2-built
#     make install-web-files



all: top2.html top2.ps top2.pdf

clean::
	rm -f *.aux *.log *.dvi  *.annot top.doc top.tex top.ps top.pdf top2.ps top2.pdf top2.ggl top2.blg top2.html top2.image.tex top2.tex bind-doc.pdf bind-doc.ps bind-wmm-2.bbl bind-wmm-2.blg bind-wmm-2.pdf bind-wmm-2.ps  paper.bbl paper.blg paper.tex s
	rm -f bind-doc-2.ps bind-doc-2.pdf bind-2.tex bind-2.thy
	rm -f binding.1.aux  binding.1.tex  binding.2.aux  binding.2.tex  binding.3.aux  binding.3.tex  binding.4.aux  binding.4.tex  binding.5.aux   binding.5.tex  binding.6.alltt.tex  binding.6b.aux  binding.6b.tex  binding.6bScript.sml
	rm -f test10.0.alltt test10.2.aux test10.4.alltt test10.aux test10.meta.tex test10.tex test10.v test10_homs.alltt test10st.tex test10.2.alltt test10.2.tex test10.7.alltt test10.meta.aux test10.ml test10.thy test10Script.sml test10st.aux test21.1.alltt
	rm -f test11.alltt test12.thy test12.v test13.aux test13.tex test13d.aux test13d.tex test17.10.aux test17.10.tex test7tt.mng.alltt.tex
	rm -f slides-arg.dvi
	rm -f slides-sl.dvi 
	rm -f slides-icfp.dvi
	rm -f slides-parsec.dvi 
	rm -f grammar_parser.tex *.mly-y2l grammar_parser_hevea.tex
	rm -f top2*.gif top2.haux top2.htoc top2.lof 
	rm -f squishtex.hand.alltt.tex
	rm -f options.txt test7.tex test7afilter.out.ps test7tt.tex test8.tex tmp.dot tmp_0.dot tmp_1.dot tmp_2.dot top.toc top2.bbl top2.toc version.tex x.tex
	rm -f bind.tex bind.thy
	rm -f test10_tuple.tex test10_tuple.thy test10_tuple.v test10_tupleScript.sml test10b.tex test10b.thy test10b.v test10bScript.sml test10st_narrow.tex test10st_narrow.thy test10st_narrow.v test10st_narrowScript.sml
	rm -f test10.alltt.tex test10_html.html 
	rm -f README.tex
	rm -f *~

realclean::
	rm -f .depend


test1.tex: ../src/ott  ../tests/test1.ott
	../src/ott  -colour true -showraw true  			\
	       -o test1.tex						\
	       -tex_show_meta true                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testOne					\
                ../tests/non_super_tabular.ott ../tests/test1.ott                                      

test8.tex: ../src/ott  ../tests/test8.ott
	../src/ott  -colour true -showraw true  			\
	       -o test8.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testEight					\
                ../tests/non_super_tabular.ott ../tests/test8.ott                                      


test10.lem test10.tex: ../src/ott  ../tests/test10.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTen					\
	       -o test10.thy 					\
	       -o test10.v 						\
	       -o test10Script.sml                                    \
	       -o test10.lem                                    \
	       -o test10.ml                                         \
                ../tests/non_super_tabular.ott ../tests/test10.ott                                      

test10_poster.tex: ../src/ott  ../tests/test10_poster.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10_poster.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTenPoster					\
	       -o test10_poster.thy 					\
	       -o test10_poster.v 						\
	       -o test10_posterScript.sml                                    \
	       -o test10_poster.ml                                         \
                ../tests/non_super_tabular.ott ../tests/test10_poster.ott                                      
test10.despaced.v: test10.tex
	cat test10.v | sed -e 's/\n\n/\n/g' > test10.despaced.v

test10.2.tex: ../src/ott  ../tests/non_super_tabular.ott ../tests/test10.2.ott 
	../src/ott  -colour true -showraw true    \
	       -o test10.2.tex                  \
	       -tex_show_meta false               \
	       -tex_wrap false                    \
	       -tex_name_prefix	testTenTwo        \
                ../tests/non_super_tabular.ott  ../tests/test10.2.ott                                      

test10.2.ps: ../src/ott  ../tests/test10.2.ott
	../src/ott  -colour true -showraw true    \
	       -o test10.2.tex                  \
	       -tex_show_meta false               \
	       -tex_wrap true                    \
	       -tex_name_prefix	testTenTwo        \
                ../tests/non_super_tabular.ott ../tests/test10.2.ott                                      
	latex test10.2 && dvips test10.2


test10.0.alltt: ../src/ott ../tests/test10.0.ott 
	../src/ott -alltt test10.0.alltt ../tests/test10.0.ott
test10.2.alltt: ../src/ott ../tests/test10.2.ott 
	../src/ott -alltt test10.2.alltt ../tests/test10.2.ott
test10.4.alltt: ../src/ott ../tests/test10.4.ott 
	../src/ott -alltt test10.4.alltt ../tests/test10.4.ott
test10.7.alltt: ../src/ott ../tests/test10.7.ott 
	../src/ott -alltt test10.7.alltt ../tests/test10.7.ott

test10.alltt.tex: ../src/ott ../tests/test10.ott 
	../src/ott -alltt test10.alltt.tex ../tests/test10.ott

test22.1.alltt.tex: ../src/ott ../tests/test22.1.ott 
	../src/ott -alltt test22.1.alltt.tex ../tests/test22.1.ott

test10_poster.alltt.tex: ../src/ott ../tests/test10_poster.ott 
	../src/ott -alltt test10_poster.alltt.tex ../tests/test10_poster.ott

test10_html.html: test10.alltt.tex test10_html.tex
	hevea -fix test10_html.tex

test11.alltt: ../src/ott ../tests/test11.ott 
	../src/ott -alltt test11.alltt ../tests/test11.ott

test10_homs.alltt: ../src/ott ../tests/test10_homs.ott 
	../src/ott -alltt test10_homs.alltt ../tests/test10_homs.ott

test20.0.alltt: ../src/ott ../tests/test20.0.ott 
	../src/ott -alltt test20.0.alltt ../tests/test20.0.ott

test21.1.alltt: ../src/ott ../tests/test21.1.ott 
	../src/ott -alltt test21.1.alltt ../tests/test21.1.ott

test22.0.alltt: ../src/ott ../tests/test22.0.ott 
	../src/ott -alltt test22.0.alltt ../tests/test22.0.ott

binding.6.alltt.tex: ../src/ott ../tests/binding.6.ott
	../src/ott -alltt binding.6.alltt.tex ../tests/binding.6.ott

squishtex.hand.alltt.tex: ../src/ott squishtex.hand.ott
	../src/ott -alltt squishtex.hand.alltt.tex squishtex.hand.ott

##let.alltt.tex: ../src/ott ../examples/tapl/let.ott
##	../src/ott -alltt let.alltt.tex ../examples/tapl/common.ott ../examples/tapl/common_typing.ott.. /examples/tapl/let.ott

# commented out, as running this - while producing the output we need - also produces an error.  It's not a well-formed standalone file.
#let.alltt.tex: ../src/ott ../examples/tapl/let.ott
#	../src/ott -alltt let.alltt.tex ../examples/tapl/let.ott



test10_tuple.tex: ../src/ott  ../tests/test10_tuple.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10_tuple.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTentuple					\
	       -o test10_tuple.thy 					\
	       -o test10_tuple.v 						\
	       -o test10_tupleScript.sml                                    \
                ../tests/non_super_tabular.ott ../tests/test10_tuple.ott                                      

test10b.tex: ../src/ott  ../tests/test10b.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10b.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTenb					\
	       -o test10b.thy 					\
	       -o test10b.v 						\
	       -o test10bScript.sml                                    \
               ../tests/test10b.ott

test10c.tex: ../src/ott  ../tests/test10c.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10c.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTenc					\
	       -o test10c.thy 					\
	       -o test10c.v 						\
	       -o test10cScript.sml                                    \
                ../tests/non_super_tabular.ott ../tests/test10c.ott                                      

test10st_narrow.tex: ../src/ott  ../tests/test10st_narrow.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10st_narrow.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTenstnarrow					\
	       -o test10st_narrow.thy 					\
	       -o test10st_narrow.v 						\
	       -o test10st_narrowScript.sml                                    \
                ../tests/non_super_tabular.ott ../tests/test10st_narrow.ott                                      

test10.meta.tex: ../src/ott  ../tests/test10.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10.meta.tex						\
	       -tex_show_meta true                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTenMeta					\
                ../tests/non_super_tabular.ott ../tests/test10.ott                                      

test10st.tex: ../src/ott  ../tests/test10st.ott
	../src/ott  -colour true -showraw true  			\
	       -o test10st.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testTenst					\
                ../tests/non_super_tabular.ott ../tests/test10st.ott                                      
#	       -o test10.thy 						\
#	       -o test10.v 						\

test7.tex: ../src/ott ../tests/test7.ott ../tests/test7tt.mng
	cd ../src; make tmp_test7_clean.ott
	../src/ott                                 			\
	       -o test7.tex						\
	       -tex_show_meta false                                     \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testSeven				\
               -tex_filter ../tests/test7tt.mng test7tt.tex               \
                ../tests/non_super_tabular.ott ../src/tmp_test7_clean.ott

test7tt.mng.alltt.tex: ../tests/test7tt.mng
	cat ../tests/test7tt.mng | sed -e 's/\\/BACKSLASH/g' | sed -e 's/{/LEFTBRACKET/g' | sed -e 's/}/\\myrb\{\}/g' | sed -e 's/LEFTBRACKET/\\mylb\{\}/g' | sed -e 's/BACKSLASH/\\mybackslash\{\}/g'  | sed -e 's/\[\[/\\mysym{\[\[}/g' | sed -e 's/\]\]/\\mysym{\]\]}/g' | sed -e 's/:concrete:/\\mykw\{:concrete:\}/g' > test7tt.mng.alltt.tex

#	cat ../tests/test7tt.mng | sed -e 's/{/\\mylb\{\}/g' | sed -e 's/}/\\myrb\{\}/g' | sed -e 's/\[\[/\\mysym\{\[\[\}/g' | sed -e 's/\]\]/\\mysym\{\]\]\}/g' | sed -e 's/\\/\\mybackslash\{\}/g' | sed -e 's/:concrete:/\\mykw\{:concrete\}/g' > test7tt.mng.alltt.tex



test12.thy: ../src/ott  ../tests/test12.ott
	../src/ott  -colour true -showraw true  			\
	       -o test12.thy 						\
	       -o test12.v 						\
	       ../tests/test12.ott

test13.tex: ../src/ott  ../tests/test13.ott
	../src/ott  -colour true -showraw true  			\
	       -o test13.tex						\
	       -tex_show_meta false                                      \
	       -tex_wrap false                                          \
	       -tex_name_prefix	testThirteen					\
                ../tests/non_super_tabular.ott ../tests/test13.ott                                      
#	       -o test10.thy 						\
#	       -o test10.v 						\

=== hol/Makefile ===
all:
	Holmake

clean:
	rm -f *Theory.* *.ui *.uo
	rm -rf .HOLMK .hollogs

=== examples/1Bsemantics/Makefile ===

OTT=../../bin/ott

l1: l1.ott
	$(OTT) -pp_grammar -isa_syntax true l1.ott -o l1.tex -o l1.thy -o l1.lem
	$(OTT) -tex_wrap false l1.ott -o l1_nowrap.tex 
	pdflatex l1.tex
	lem l1.lem  -isa

l2: l1.ott l2.ott
	$(OTT) -merge true l1.ott l2.ott -o l2.tex -o l2.thy -o l2.tmp.lem
	pdflatex l2.tex
	(echo 'open import Pervasives' ; cat l2.tmp.lem) > l2.lem
	lem l2.lem -isa


clean:
	rm -rf *~
	rm -rf l1.tex l1.thy l1.lem l1_nowrap.tex L1.thy
	rm -rf l2.tex l2.thy l2.tmp.lem l2.lem l2.thy L2.thy
	rm -rf l1.aux l1.log l1.pdf
	rm -rf l2.aux l2.log l2.pdf
	rm -rf L1Auxiliary.thy L2Auxiliary.thy

=== examples/ocaml_light/Makefile ===
## Default target: run ott, and typeset the spec.
default: ott ps pdf
## Run ott, and compile the spec in proof assistants (Coq, HOL and Isabelle).
all: default coq-def hol-def isa-def
## Build everything. Requires Coq, Isabelle, and HOL.
## See hol/README for HOL version requirement.
world: all hol-proof


lemtest: 
	make -C ../../src
	make caml_typedef.lem
	~/bitbucket/lem/lem  -wl_unused_vars ign -ocaml caml_typedef.lem



#### Options for ott hackers ####
## Run `make separate_ott_runs=1' to run a separate ott process for
## each output languages (slower, but sometimes useful in case of
## language-specific bugs in ott).
separate_ott_runs =

#### General targets ####
ott: caml_typedef.tex caml_typedef.v caml_typedefScript.sml caml_typedef.thy
ps: caml_typedef.ps
pdf: caml_typedef.pdf
coq-def: caml_typedef.vo
hol-def: caml_typedefTheory.uo hol_caml
isa-def: caml_typedef.isa
coq: coq-def
hol: hol-def
isa: isa-def
hol-proof: hol/definitionsTheory.uo hol/defs_red_funTheory.uo

install_doc: caml_typedef.pdf
	cp caml_typedef.pdf doc/built_doc

#### Directories ####
############ CHANGE topdir TO REFER TO YOUR TOP LEVEL OTT INSTALLATION ########
topdir = ../..
#/home/so294/scratch/ott_distro_0.10.13
ott_coq_lib_dir = $(topdir)/coq
ott_hol_lib_dir = $(topdir)/hol
poly_lib = /Users/so294/polyml.5.1/lib

#### Programs and their arguments ####
COQC = coqc
#COQ_INCLUDE = -I $(ott_coq_lib_dir)
COQ_INCLUDE = -R $(ott_coq_lib_dir) Ott
COQ_FLAGS =
DVIPS = dvips
DVIPSFLAGS = -Ppdf -j0 -G0
HOLMAKE = Holmake
HOLMAKE_INCLUDE = -I $(ott_hol_lib_dir)
HOLMAKE_FLAGS = --qof
ISABELLE = isabelle
ISABELLE_FLAGS = -q
ISABELLE_WRAPPER = use_thy "$*" handle e => (TextIO.output (TextIO.stdErr, "Isabelled failed: " ^ exnMessage e ^ "\n"); OS.Process.exit OS.Process.failure)
LATEX = latex
OTT = $(topdir)/src/ott
#OTT = $(topdir)/bin/ott
OTT_COMMON_FLAGS = -pp_grammar -tex_show_categories true -coq_expand_list_types false -isa_generate_lemmas false
## Run `make OTT_VERBOSITY_FLAGS= target' to cause ott to spew out a
## lot of debugging output.
OTT_VERBOSITY_FLAGS = -show_defns false  -tex_show_categories true
#-show_post_sort false
OTT_FLAGS = -no_rbcatn true $(OTT_COMMON_FLAGS) $(OTT_VERBOSITY_FLAGS)
# -lem_debug true 
PS2PDF = ps2pdf

#### Preprocessing ####
caml_sources = syntax typing reduction
caml_combinations = \
	caml_plain caml_module caml_module_typedef caml_typedef

## Extract the desired language fragment
caml_plain_%.ott: %.ott
	cat $< >$@.tmp
	mv -f $@.tmp $@
caml_module_%.ott: %.ott
	sed -e 's/\(\(%[^%]\)*\)%m/\1/' $< >$@.tmp
	mv -f $@.tmp $@
caml_typedef_%.ott: %.ott
	sed -e 's/\(\(%[^%]\)*\)%d/\1/' $< >$@.tmp
	mv -f $@.tmp $@
caml_module_typedef_%.ott: %.ott
	sed -e 's/\(\(%[^%]\)*\)%d/\1/' -e 's/\(\(%[^%]\)*\)%m/\1/' $< >$@.tmp
	mv -f $@.tmp $@

## Multiple extraction targets
caml_%.ott: caml_%_syntax.ott caml_%_typing.ott caml_%_reduction.ott ;

#### Ott ####
ifeq ($(separate_ott_runs),)
## One ott run to produce everything
caml%.rawtex caml%.v caml%Script.sml caml%.thy caml%.lem: \
  caml%_syntax.ott caml%_typing.ott caml%_reduction.ott $(OTT)
	# Note: no protection against interruptions for hol and isabelle,
	# because ott requires a file name ending in Script.sml.
	$(OTT) $(OTT_FLAGS)  -o caml$*.tmp.tex -o caml$*.tmp.v -o caml$*Script.sml -o caml$*.thy -o caml$*.lem caml$*_syntax.ott caml$*_typing.ott caml$*_reduction.ott
	mv -f caml$*.tmp.tex caml$*.rawtex
	mv -f caml$*.tmp.v caml$*.v
else
## Separate ott runs, one per target
caml%.rawtex: caml%_syntax.ott caml%_typing.ott caml%_reduction.ott $(OTT)
	$(OTT) $(OTT_FLAGS) -o $@ $(@:.tex=)_syntax.ott $(@:.tex=)_typing.ott $(@:.tex=)_reduction.ott
#	mv -f $@.tmp $@
caml%Script.sml: caml%_syntax.ott caml%_typing.ott caml%_reduction.ott $(OTT)
	# Note: no protection against interruptions, because ott requires
	# a file name ending in Script.sml.
	$(OTT) $(OTT_FLAGS) -o $@ $(@:Script.sml=)_syntax.ott $(@:Script.sml=)_typing.ott $(@:Script.sml=)_reduction.ott
caml%.thy: caml%_syntax.ott caml%_typing.ott caml%_reduction.ott $(OTT)
	# Note: no protection against interruptions, because ott requires
	# a file name ending in .thy.
	$(OTT) $(OTT_FLAGS) -o $@ $(@:.thy=)_syntax.ott $(@:.thy=)_typing.ott $(@:.thy=)_reduction.ott
caml%.v: caml%_syntax.ott caml%_typing.ott caml%_reduction.ott $(OTT)
	$(OTT) $(OTT_FLAGS) -coq_expand_list_types false -o $@ $(@:.v=)_syntax.ott $(@:.v=)_typing.ott $(@:.v=)_reduction.ott
#	mv -f $@.tmp $@
caml%.lem: caml%_syntax.ott caml%_typing.ott caml%_reduction.ott $(OTT)
	$(OTT) $(OTT_FLAGS)  -o $@ $(@:.v=)_syntax.ott $(@:.v=)_typing.ott $(@:.v=)_reduction.ott
#	mv -f $@.tmp $@
endif

caml%.grammar: caml%_syntax.ott caml%_typing.ott caml%_reduction.ott $(OTT)
	$(OTT) $(OTT_FLAGS) -writesys $@.tmp $(@:.grammar=)_syntax.ott $(@:.grammar=)_typing.ott $(@:.grammar=)_reduction.ott
	mv -f $@.tmp $@

$(OTT): %:
#	cd $(@D) && $(MAKE) $(@F)

## Generate all combinations
caml_combinationsScript.sml: $(caml_combinations:=Script.sml) ;
caml_combinations.dvi: $(caml_combinations:=.dvi) ;
caml_combinations.pdf: $(caml_combinations:=.pdf) ;
caml_combinations.ps: $(caml_combinations:=.ps) ;
caml_combinations.tex: $(caml_combinations:=.tex) ;
caml_combinations.thy: $(caml_combinations:=.thy) ;
caml_combinations.v: $(caml_combinations:=.v) ;

#### TeX ####
%.tex: %.rawtex ott-preamble.sed
	sed -f ott-preamble.sed <$< >$@.tmp
	mv -f $@.tmp $@

.SUFFIXES: .tex .dvi .ps .pdf
.tex.dvi:
	$(LATEX) $<
	$(LATEX) $<
	$(LATEX) $<
.dvi.ps:
	$(DVIPS) $(DVIPS_FLAGS) -o $@ $<
.ps.pdf:
	$(PS2PDF) $< $@

#### Coq ####
coq_libs = $(ott_coq_lib_dir)/ott_list
coq-libs: $(coq_libs:=.vo)
$(coq_libs:=.vo): %:
	cd $(@D) && $(MAKE) $(@F)
.SUFFIXES: .v .vo
.v.vo:
	$(COQC) $(COQ_INCLUDE) $(COQ_FLAGS) $<

#### Hol ####
dummy:

hol_caml.o: caml_typedefTheory.uo hol_caml.ML
	hol.builder < hol_caml.ML

hol_caml: hol_caml.o
	cc -L$(poly_lib) -o hol_caml -lpolymain -lpolyml hol_caml.o

hol_libs = $(topdir)/hol/ottLib $(topdir)/hol/ottTheory
hol-libs: $(hol_libs:=.ui) $(hol_libs:=.uo)
$(hol_libs:=.ui) $(hol_libs:=.uo): %:
	cd $(@D) && $(MAKE) $(@F)
%Theory.uo: %Script.sml hol-libs
	$(HOLMAKE) $(HOLMAKE_INCLUDE) $(HOLMAKE_FLAGS) $@
hol/Holmakefile: Makefile
	rm -f hol/Holmakefile
	echo INCLUDES = .. ../$(ott_hol_lib_dir) > hol/Holmakefile
hol/testing/Holmakefile: Makefile
	rm -f hol/testing/Holmakefile
	echo INCLUDES = .. ../.. $(ott_hol_lib_dir) > hol/testing/Holmakefile
hol/definitionsTheory.uo: caml_typedefTheory.uo hol/Holmakefile hol/testing/Holmakefile dummy hol-def
	cd $(@D) && $(HOLMAKE) $(HOLMAKE_FLAGS) --poly ../hol_caml $(@F)
hol/defs_red_funTheory.uo: caml_typedefTheory.uo hol/Holmakefile hol/testing/Holmakefile dummy hol-def
	cd $(@D) && $(HOLMAKE) $(HOLMAKE_FLAGS) --poly ../hol_caml $(@F)

hol/ocamlpp/filter:
	cd $(@D) && $(MAKE) $(@F)

#### Isabelle ####
.SUFFIXES: .thy .isa
.thy.isa:
	$(ISABELLE) $(ISABELLE_FLAGS) -e '$(ISABELLE_WRAPPER)'
	touch $@ # TODO: can Isabelle produce a proof trace of some kind?

#### Cleanup ####
clean:
	rm -f *.grammar *.rawtex
	rm -f *.aux *.dvi *.lof *.log *.lot *.ps *.pdf *.toc
	rm -f *.vo *.ui *.uo *.isa
	rm -f $(caml_combinations:=_syntax.ott) $(caml_combinations:=_typing.ott) $(caml_combinations:=_reduction.ott)
	rm -f $(caml_combinations:=.tex) $(caml_combinations:=Script.sml) $(caml_combinations:=.thy) $(caml_combinations:=.v)
	rm -f *Theory.sig *Theory.sml
	rm -f *.tmp tmp.* hol_caml
	rm -rf .HOLMK
	rm -rf *~

#### Dependencies ####
## Ott preprocessed sources
$(caml_combinations:=_syntax.ott):
$(caml_combinations:=_typing.ott):
$(caml_combinations:=_reduction.ott):
## Ott output
$(caml_combinations:=.rawtex): $(OTT)
$(caml_combinations:=.tex): $(OTT)
$(caml_combinations:=.dvi): ott-spec.ltx
$(caml_combinations:=.v): $(OTT)
$(caml_combinations:=Script.sml): $(OTT)
$(caml_combinations:=.thy): $(OTT)
## Coq
$(caml_combinations:=.vo): caml_lib_misc.vo
caml_base.vo: caml_base.v caml_typedef.vo
caml_examples_adhoc_1.vo: caml_examples_adhoc_1.v caml_typedef.vo caml_base.vo

#### The End ####

=== tests/test10literate/Makefile ===
all: test10.pdf test10-wrapper.pdf

# first way
test10.tex: test10.ott Makefile
	../../bin/ott -i test10.ott -o test10.tex

test10.pdf: test10.tex
	pdflatex test10.tex

# second way (usually better)
test10-inc.tex: test10.ott Makefile
	../../bin/ott -tex_wrap false -i test10.ott -o test10-inc.tex

test10-wrapper.pdf: test10-inc.tex test10-wrapper.tex
	pdflatex test10-wrapper.tex


clean:
	rm -rf *~
	rm -rf test10.tex *.aux *.log test10.pdf test10-inc.tex test10-wrapper.pdf

=== tests/menhir_tests/test_phantom/Makefile ===
#  make -C ../.. && make clean && make

ROOT            := test_phantom

OTTDIR          := ../../..

OTT             := $(OTTDIR)/bin/ott

MENHIR_EXTRA_LIB:= $(OTTDIR)/menhir/menhir_library_extra.mly

MENHIR          := menhir

MENHIRFLAGS     := --infer --explain --unused-tokens --trace --base $(ROOT)_parser

OCAMLBUILD      := ocamlbuild -use-ocamlfind -use-menhir -menhir "$(MENHIR) $(MENHIRFLAGS) ../$(MENHIR_EXTRA_LIB) "

MAIN            := main

all: $(ROOT)_ast.ml $(ROOT)_parser.mly $(ROOT)_parser_pp.ml $(ROOT)_lexer.mll main.ml 
	$(OCAMLBUILD) $(MAIN).byte


pdf: $(ROOT)_quotiented.pdf $(ROOT)_unquotiented.pdf

# generate the ocaml AST type, ocamllex lexer, menhir parser, and ocaml pretty printers for the AST, all from the Ott soruce
$(ROOT)_ast.ml  $(ROOT)_lexer.mll $(ROOT)_parser.mly $(ROOT)_parser_pp.ml $(ROOT)_ast.tex : $(ROOT).ott
	$(OTT) -show_sort true -quotient_rules false -i $(ROOT).ott  -o $(ROOT)_parser.mly -o $(ROOT)_lexer.mll -o $(ROOT)_ast.ml -o $(ROOT).tex


$(ROOT)_quotiented.pdf: $(ROOT).ott Makefile
	$(OTT) -quotient_rules true -i $(ROOT).ott -o $(ROOT)_quotiented.tex
	pdflatex $(ROOT)_quotiented.tex

$(ROOT)_unquotiented.pdf: $(ROOT).ott Makefile
	$(OTT) -quotient_rules false -i $(ROOT).ott -o $(ROOT)_unquotiented.tex
	pdflatex $(ROOT)_unquotiented.tex

clean:
	rm -rf *~
	rm -rf _build
	rm -rf $(ROOT)_ast.ml $(ROOT)_parser.mly $(ROOT)_lexer.mll $(ROOT)_parser_pp.ml
	rm -rf *.aux *.log *.tex
	rm -rf main.native main.byte
	$(OCAMLBUILD) -clean

realclean:
	$(MAKE) clean
	rm -rf *.pdf

=== debian/changelog ===
ott (0.33+ds-1build1) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Jul 2023 07:13:44 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends: coq,
                debhelper-compat (= 13),
